package com.huiju.welcome.controller;

import com.huiju.welcome.common.base.BaseController;
import com.huiju.welcome.common.base.ResponseBean;
import com.huiju.welcome.model.TaGoodsImg;
import com.huiju.welcome.service.ITaGoodsImgService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
    *  前端控制器
    * </p>
 *
 * @author jobob
 * @since 2019-07-16
 */
@RestController
@RequestMapping("/")
public class TaGoodsImgController extends BaseController {

    private final Logger logger = LoggerFactory.getLogger(TaGoodsImgController.class);

    @Autowired
    public ITaGoodsImgService iTaGoodsImgService;


    /**
     * 保存对象
     * @param taGoodsImg 实体对象
     * @return
     */
    @RequestMapping(value="/taGoodsImg/add",method= RequestMethod.POST)
    public ResponseBean tpShopImgAdd(@RequestBody TaGoodsImg taGoodsImg){
        ResponseBean responseBean = new ResponseBean();
        try {
            if (iTaGoodsImgService.save(taGoodsImg)){
                responseBean.addSuccess("success");
            }else {
                responseBean.addError("fail");
            }
        }catch (Exception e){
            logger.error("taGoodsImgAdd -=- {}",e.toString());
            responseBean.addError(e.getMessage());
        }
        return responseBean;
    }

    /**
     * 根据id删除对象
     * @param id  实体ID
     */
    @ResponseBody
    @RequestMapping(value="/taGoodsImg/delete/{id}", method= RequestMethod.DELETE)
    public ResponseBean taGoodsImgDelete(@PathVariable Integer id){
        ResponseBean responseBean = new ResponseBean();
        try {
            if(iTaGoodsImgService.removeById(id)){
                responseBean.addSuccess("success");
            }else {
                responseBean.addError("fail");
            }
        }catch (Exception e){
            logger.error("taGoodsImgDelete -=- {}",e.toString());
            responseBean.addError(e.getMessage());
        }
        return responseBean;
    }

    /**
     * 修改对象
     * @param taGoodsImg 实体对象
     * @return
     */
    @RequestMapping(value="/taGoodsImg/update",method= RequestMethod.PUT)
    public ResponseBean tpShopImgUpdate(@RequestBody TaGoodsImg taGoodsImg){
        ResponseBean responseBean = new ResponseBean();
        try {
            if (iTaGoodsImgService.updateById(taGoodsImg)){
                responseBean.addSuccess("success");
            }else {
                responseBean.addError("fail");
            }
        }catch (Exception e){
            logger.error("taGoodsImgUpdate -=- {}",e.toString());
            responseBean.addError(e.getMessage());
        }
        return responseBean;
    }

    /**
     * 根据id查询对象
     * @param id  实体ID
     */
    @RequestMapping(value="/taGoodsImg/get/{id}",method= RequestMethod.GET)
    public ResponseBean tpShopImgGet(@PathVariable Integer id){
        ResponseBean responseBean = new ResponseBean();
        try {
            responseBean.addSuccess(iTaGoodsImgService.getById(id));
        }catch (Exception e){
            logger.error("taGoodsImgDelete -=- {}",e.toString());
            responseBean.addError(e.getMessage());
        }
        return responseBean;
    }
}
